ghc-7.0.3: The GHC API

TcPat

# Documentation

tcLetPat :: TcSigFun -> LetBndrSpec -> LPat Name -> TcSigmaType -> TcM a -> TcM (LPat TcId, a)

type TcSigFun = Name -> Maybe TcSigInfo

data TcSigInfo

Constructors

TcSigInfo |

Fields

sig_id :: TcId
sig_scoped :: [Name]
sig_tvs :: [TcTyVar]
sig_theta :: TcThetaType
sig_tau :: TcSigmaType
sig_loc :: SrcSpan

Instances

Outputable TcSigInfo |

type TcPragFun = Name -> [LSig Name]

data LetBndrSpec

Constructors

LetLclBndr |
LetGblBndr TcPragFun |

addInlinePrags :: TcId -> [LSig Name] -> TcM TcId

warnPrags :: Id -> [LSig Name] -> SDoc -> TcM ()

tcPat :: HsMatchContext Name -> LPat Name -> TcSigmaType -> TcM a -> TcM (LPat TcId, a)

tcPats :: HsMatchContext Name -> [LPat Name] -> [TcSigmaType] -> TcM a -> TcM ([LPat TcId], a)

newNoSigLetBndr :: LetBndrSpec -> Name -> TcType -> TcM TcId

newSigLetBndr :: LetBndrSpec -> Name -> TcSigInfo -> TcM TcId

addDataConStupidTheta :: DataCon -> [TcType] -> TcM ()

badFieldCon :: DataCon -> Name -> SDoc

polyPatSig :: TcType -> SDoc